﻿import cristalab.galeria.Preloader;
class cristalab.galeria.Foto {
	private var ruta_mc:MovieClip;
	private var popup_mc:MovieClip;
	private var ambito;
	private var imagen:Number;
	function Foto(imagen:Number, ruta:MovieClip) {
		var init:Object;
		init.img = imagen;
		this.imagen = imagen;
		ruta_mc = ruta;
		ruta_mc.attachMovie("fPopup", "pop_mc", ruta_mc.getNextHighestDepth(), init);
		popup_mc = ruta_mc.pop_mc;
		ubicar();
	}
	public function reload():Void {
		popup_mc.container_mc.img_mc._x = popup_mc.container_mc.img_mc._y=0;
		popup_mc.container_mc.img_mc.unloadMovie();
		cargarImagen();
	}
	public function atras():Void {
		if (this.imagen>1) {
			imagen--;
			reload();
		}
	}
	public function adelante():Void {
		if (this.imagen<ruta_mc.galeria.nImagenes) {
			imagen++;
			reload();
		}
	}
	public function ubicar():Void {
		popup_mc._x = (ruta_mc._width/2)-(popup_mc._width/2);
		popup_mc._y = (ruta_mc._height/2)-(popup_mc._height/2);
	}
	public function cargarImagen():Void {
		with (popup_mc) {
			cerrar_btn.enabled = atras_btn.enabled=adelante_btn.enabled=false;
			navbar_mc._visible = false;
		}
		var precarga:Preloader = new Preloader(popup_mc.container_mc.img_mc, "http://www.cristalab.com/files/ejemplos/galeriaOOP/images/normal/"+imagen+".jpg", popup_mc.drw_mc, popup_mc.container_mc, this, onLoadImg);
	}
	private function onLoadImg():Void {
		//ruta_mc.img_mc._visible=false;
		ruta_mc.img_mc._x=ruta_mc.img_mc._y=0;
		var hilo = setInterval(function (amb) {
			ruta_mc.img_mc._x = (ruta_mc._width/2)-(ruta_mc.img_mc._width/2);
			ruta_mc.img_mc._y = (ruta_mc._height/2)-(ruta_mc.img_mc._height/2);
			amb.showElements();
			clearInterval(hilo);
		}, 100,ambito);
	}
	private function showElements() {
		popup_mc.container_mc.img_mc._visible=true;
		popup_mc.container_mc.img_mc.useHandCursor = false;
		popup_mc.container_mc.img_mc.clase = this;
		popup_mc.container_mc.img_mc.ruta_mc = ruta_mc;
		popup_mc.container_mc.attachMovie("transicion","trans_mc",popup_mc.container_mc.getNextHighestDepth());
		popup_mc.container_mc.img_mc.onRollOver = function() {
			Mouse.hide();
			var init:Object = new Object();
			init._x = ruta_mc._xmouse;
			init._y = ruta_mc._ymouse;
			ruta_mc.cursor_mc.removeMovieClip();
			ruta_mc.attachMovie("handCursor", "cursor_mc", ruta_mc.getNextHighestDepth(), init);
		};
		popup_mc.container_mc.img_mc.onRollOut = function() {
			Mouse.show();
			ruta_mc.cursor_mc.removeMovieClip();
		};
		popup_mc.container_mc.img_mc.onMouseDown = function() {
			this.startDrag(false, 0, 0, -1*(this._width)+366.7, -1*(this._height)+363.9);
			Mouse.hide();
			var init:Object = new Object();
			init._x = ruta_mc._xmouse;
			init._y = ruta_mc._ymouse;
			ruta_mc.cursor_mc.removeMovieClip();
			ruta_mc.attachMovie("handCursor", "cursor_mc", ruta_mc.getNextHighestDepth(), init);
		};
		popup_mc.container_mc.img_mc.onMouseMove = function() {
			ruta_mc.cursor_mc._x = ruta_mc._xmouse;
			ruta_mc.cursor_mc._y = ruta_mc._ymouse;
			this.clase.drawZoom(ruta_mc.pop_mc.bb);
			updateAfterEvent();
		};
		popup_mc.container_mc.img_mc.onMouseUp = function() {
			Mouse.show();
			this.stopDrag();
			ruta_mc.cursor_mc.removeMovieClip();
		};
		popup_mc.titulo_txt.text = ".:: Imagen Nº "+imagen+" ::.";
		popup_mc.navbar_mc.imagen_txt.text = "Imagen Nº "+imagen;
		with (popup_mc) {
			cerrar_btn.enabled = atras_btn.enabled=adelante_btn.enabled=true;
			navbar_mc._visible = true;
			navbar_mc.tamano_txt.text = container_mc.img_mc._width+"px x "+container_mc.img_mc._height+"px";
		}
	}
	public function drawZoom(board_mc:MovieClip):Void {
		var con_mc:MovieClip = popup_mc.container_mc.img_mc;
		board_mc.clear();
		board_mc.lineStyle(1, 0x000000, 100);
		board_mc.beginFill(0xFFFFFF, 50);
		board_mc.moveTo(0, 0);
		board_mc.lineTo(con_mc._width*.1, 0);
		board_mc.lineTo(con_mc._width*.1, con_mc._height*.1);
		board_mc.lineTo(0, con_mc._height*.1);
		board_mc.endFill();
		var x:Number = -1*(con_mc._x*.1);
		var y:Number = -1*(con_mc._y*.1);
		board_mc.moveTo(x, y);
		board_mc.lineTo(x, y+36.43);
		board_mc.lineTo(x+33.69, y+36.43);
		board_mc.lineTo(x+33.69, y);
		board_mc.lineTo(x, y);
	}
}
